<!doctype html>
<html lang="en">
<head>

<meta charset="UTF-8">
<title>Hello, WebAuthn!</title>

</head>
<body>

<h1>Hello, WebAuthn!</h1>

<form action="#">

<p>email: <input type="text" id="email" placeholder="email@example.com"></p>

<br>
<button id="register">Register</button><br>

</form>

<br>

<p id="message"></p>

<br>

<a href="index.html">TOP</a><br>

<script>
document.addEventListener("DOMContentLoaded", function(){
  document.getElementById("register").addEventListener("click", register);
});

async function register(){
  try {
    if (!window.PublicKeyCredential) {
      throw "Oops! this browser does not support WebAuthn...";
    }

    const user = getUser();
    const {publicKey} = await begin({user});
    const credential = await navigator.credentials.create({publicKey});
    const result = await finish({credential});

    document.getElementById("message").innerHTML = result;
  } catch (e) {
    document.getElementById("message").innerHTML = e;
  }
}

function getUser() {
  const email = document.getElementById("email").value;

  if (email.length == 0) {
    throw "email is empty";
  }

  return {email};
}

async function begin({user}) {
  const response = await fetch("/registration/begin", {
    method: "POST",
    headers: { "Content-Type": "application/json" },
    body: JSON.stringify({
      "email": user.email,
    }),
  });

  if (!response.ok) {
    const json = await response.json();
    throw "error: failed beginning registration: " + JSON.stringify(json);
  }

  const json = await response.json();

  const publicKey = json.publicKey;
  decodePublicKey(publicKey);

  return {
    publicKey: json.publicKey,
  };
}
function decodePublicKey(publicKey) {
  publicKey.challenge = bufferDecode(publicKey.challenge);
  publicKey.user.id = bufferDecode(publicKey.user.id);
}
function bufferDecode(value) {
  return Uint8Array.from(atob(value), c => c.charCodeAt(0));
}

async function finish({credential}) {
  const response = await fetch("/registration/finish", {
    method: "POST",
    headers: { "Content-Type": "application/json" },
    body: JSON.stringify({
      id: credential.id,
      type: credential.type,
      rawId: bufferEncode(credential.rawId),
      response: {
        attestationObject: bufferEncode(credential.response.attestationObject),
        clientDataJSON: bufferEncode(credential.response.clientDataJSON),
      },
    }),
  });

  if (!response.ok) {
    throw "error: failed finishing registration: " + JSON.stringify(response);
  }

  const json = await response.json();

  return json;
}
function bufferEncode(value) {
  return btoa(String.fromCharCode.apply(null, new Uint8Array(value)))
    .replace(/\+/g, "-")
    .replace(/\//g, "_")
    .replace(/=/g, "");
}
</script>
</body>
</html>
